#ifndef _H_u_example
#define _H_u_example
/*
 * Copyright (c) 2008 - 2012, Andy Bierman, All Rights Reserved.
 * Copyright (c) 2012 - 2020, YumaWorks, Inc., All Rights Reserved.
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *

*** Generated by yangdump-sdk

    User SIL header
    module example
    revision 2020-03-03
    namespace http://netconfcentral.org/ns/example
    Created: 2020-03-05T23:22:42Z
    CLI parameters:
        format uh
        indent 4
        log-level debug3
        module example
        output u_example.h
        unified true

 */

#include <xmlstring.h>

#include "agt.h"
#include "agt_cb.h"
#include "dlq.h"
#include "ncxtypes.h"
#include "op.h"
#include "rpc.h"
#include "ses.h"
#include "status.h"
#include "val.h"
#include "y_example.h"

#ifdef __cplusplus
extern "C" {
#endif

/* leaf-list /system/domain-search */
typedef struct y_example_T_system_domain_search_ {
    dlq_hdr_t qhdr;
    xmlChar *v_domain_search;
} y_example_T_system_domain_search;

/* container /system */
typedef struct y_example_T_system_ {
    xmlChar *v_host_name;
    dlq_hdr_t v_domain_search;
} y_example_T_system;


/********************************************************************
* FUNCTION u_example_system_host_name_edit
*
* Edit database object callback
* Path: leaf /system/host-name
* Add object instrumentation in COMMIT phase.
*
* INPUTS:
*     see agt/agt_cb.h for details
*
* RETURNS:
*     error status
********************************************************************/
extern status_t
    u_example_system_host_name_edit (ses_cb_t *scb,
                                     rpc_msg_t *msg,
                                     agt_cbtyp_t cbtyp,
                                     op_editop_t editop,
                                     val_value_t *newval,
                                     val_value_t *curval);


/********************************************************************
* FUNCTION u_example_system_domain_search_edit
*
* Edit database object callback
* Path: leaf-list /system/domain-search
* Add object instrumentation in COMMIT phase.
*
* INPUTS:
*     see agt/agt_cb.h for details
*
* RETURNS:
*     error status
********************************************************************/
extern status_t
    u_example_system_domain_search_edit (ses_cb_t *scb,
                                         rpc_msg_t *msg,
                                         agt_cbtyp_t cbtyp,
                                         op_editop_t editop,
                                         val_value_t *newval,
                                         val_value_t *curval);


/********************************************************************
* FUNCTION u_example_system_edit
*
* Edit database object callback
* Path: container /system
* Add object instrumentation in COMMIT phase.
*
* INPUTS:
*     see agt/agt_cb.h for details
*
* RETURNS:
*     error status
********************************************************************/
extern status_t
    u_example_system_edit (ses_cb_t *scb,
                           rpc_msg_t *msg,
                           agt_cbtyp_t cbtyp,
                           op_editop_t editop,
                           val_value_t *newval,
                           val_value_t *curval);


/********************************************************************
* FUNCTION u_example_init
*
* initialize the example server instrumentation library
*
* INPUTS:
*    modname == requested module name
*    revision == requested version (NULL for any)
*
* RETURNS:
*     error status
********************************************************************/
extern status_t
    u_example_init (const xmlChar *modname,
                    const xmlChar *revision);


/********************************************************************
* FUNCTION u_example_init2
*
* SIL init phase 2: non-config data structures
* Called after running config is loaded
*
* RETURNS:
*     error status
********************************************************************/
extern status_t u_example_init2 (void);


/********************************************************************
* FUNCTION u_example_cleanup
*    cleanup the server instrumentation library
*
********************************************************************/
extern void u_example_cleanup (void);


#ifdef __cplusplus
} /* end extern 'C' */
#endif

#endif
