/*
 * Copyright (c) 2008 - 2012, Andy Bierman, All Rights Reserved.
 * Copyright (c) 2012 - 2020, YumaWorks, Inc., All Rights Reserved.
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *

*** Generated by yangdump-sdk

    YumaPro SIL module
    module example
    revision 2020-03-03
    namespace http://netconfcentral.org/ns/example
    Created: 2020-03-05T23:22:42Z
    CLI parameters:
        format yc
        indent 4
        log-level debug3
        module example
        output y_example.c
        unified true

 */

#include <xmlstring.h>

#include "procdefs.h"
#include "agt.h"
#include "agt_action.h"
#include "agt_cb.h"
#include "agt_rpc.h"
#include "agt_sil_lib.h"
#include "agt_timer.h"
#include "agt_util.h"
#include "agt_val.h"
#include "cfg.h"
#include "dlq.h"
#include "ncx.h"
#include "ncx_feature.h"
#include "ncxmod.h"
#include "ncxtypes.h"
#include "rpc.h"
#include "status.h"
#include "val.h"
#include "val_child.h"
#include "val_util.h"
#include "xml_val.h"
#include "u_example.h"
#include "y_example.h"

/* module static variables */
static ncx_module_t *example_mod;
static obj_template_t *system_obj;
static val_value_t *system_val;

/********************************************************************
* FUNCTION y_example_init_static_vars
*
* initialize module static variables
*
********************************************************************/
static void y_example_init_static_vars (void)
{
    example_mod = NULL;
    system_obj = NULL;
    system_val = NULL;

} /* y_example_init_static_vars */


/********************************************************************
* FUNCTION example_system_host_name_edit
*
* Edit database object callback
* Path: leaf /system/host-name
* Add object instrumentation in COMMIT phase.
*
* INPUTS:
*     see agt/agt_cb.h for details
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    example_system_host_name_edit (ses_cb_t *scb,
                                   rpc_msg_t *msg,
                                   agt_cbtyp_t cbtyp,
                                   op_editop_t editop,
                                   val_value_t *newval,
                                   val_value_t *curval)
{
    status_t res = NO_ERR;
    val_value_t *errorval = (curval) ? curval : newval;
    uint32 cur_errs = agt_get_error_count(msg);

    if (LOGDEBUG) {
        log_debug("\nEnter example_system_host_name_edit callback for %s phase",
            agt_cbtype_name(cbtyp));
    }

    res = u_example_system_host_name_edit(scb,
                                          msg,
                                          cbtyp,
                                          editop,
                                          newval,
                                          curval);

    if ((res != NO_ERR) && (cur_errs == agt_get_error_count(msg))) {
        agt_record_error(scb,
                         &msg->mhdr,
                         NCX_LAYER_CONTENT,
                         res,
                         NULL,
                         (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
                         errorval,
                         (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
                         errorval);
    }
    return res;

} /* example_system_host_name_edit */


/********************************************************************
* FUNCTION example_system_domain_search_edit
*
* Edit database object callback
* Path: leaf-list /system/domain-search
* Add object instrumentation in COMMIT phase.
*
* INPUTS:
*     see agt/agt_cb.h for details
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    example_system_domain_search_edit (ses_cb_t *scb,
                                       rpc_msg_t *msg,
                                       agt_cbtyp_t cbtyp,
                                       op_editop_t editop,
                                       val_value_t *newval,
                                       val_value_t *curval)
{
    status_t res = NO_ERR;
    val_value_t *errorval = (curval) ? curval : newval;
    uint32 cur_errs = agt_get_error_count(msg);

    if (LOGDEBUG) {
        log_debug("\nEnter example_system_domain_search_edit callback for %s phase",
            agt_cbtype_name(cbtyp));
    }

    res =
        u_example_system_domain_search_edit(scb,
                                            msg,
                                            cbtyp,
                                            editop,
                                            newval,
                                            curval);

    if ((res != NO_ERR) && (cur_errs == agt_get_error_count(msg))) {
        agt_record_error(scb,
                         &msg->mhdr,
                         NCX_LAYER_CONTENT,
                         res,
                         NULL,
                         (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
                         errorval,
                         (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
                         errorval);
    }
    return res;

} /* example_system_domain_search_edit */


/********************************************************************
* FUNCTION example_system_edit
*
* Edit database object callback
* Path: container /system
* Add object instrumentation in COMMIT phase.
*
* INPUTS:
*     see agt/agt_cb.h for details
*
* RETURNS:
*     error status
********************************************************************/
static status_t
    example_system_edit (ses_cb_t *scb,
                         rpc_msg_t *msg,
                         agt_cbtyp_t cbtyp,
                         op_editop_t editop,
                         val_value_t *newval,
                         val_value_t *curval)
{
    status_t res = NO_ERR;
    val_value_t *errorval = (curval) ? curval : newval;
    uint32 cur_errs = agt_get_error_count(msg);

    if (LOGDEBUG) {
        log_debug("\nEnter example_system_edit callback for %s phase",
            agt_cbtype_name(cbtyp));
    }

    res = u_example_system_edit(scb,
                                msg,
                                cbtyp,
                                editop,
                                newval,
                                curval);

    if (res == NO_ERR && cbtyp == AGT_CB_COMMIT) {
        res = agt_check_cache(&system_val, newval, curval, editop);
    }

    if ((res != NO_ERR) && (cur_errs == agt_get_error_count(msg))) {
        agt_record_error(scb,
                         &msg->mhdr,
                         NCX_LAYER_CONTENT,
                         res,
                         NULL,
                         (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
                         errorval,
                         (errorval) ? NCX_NT_VAL : NCX_NT_NONE,
                         errorval);
    }
    return res;

} /* example_system_edit */


/********************************************************************
* FUNCTION y_example_init
*
* initialize the example server instrumentation library
*
* INPUTS:
*    modname == requested module name
*    revision == requested version (NULL for any)
*
* RETURNS:
*     error status
********************************************************************/
status_t
    y_example_init (const xmlChar *modname,
                    const xmlChar *revision)
{
    status_t res = NO_ERR;

    y_example_init_static_vars();

    /* change if custom handling done */
    if (xml_strcmp(modname, y_example_M_example)) {
        return ERR_NCX_UNKNOWN_MODULE;
    }

    if (revision && xml_strcmp(revision, y_example_R_example)) {
        return ERR_NCX_WRONG_VERSION;
    }


    res =
        ncxmod_load_module(y_example_M_example,
                           y_example_R_example,
                           agt_get_savedevQ(),
                           &example_mod);
    if (res != NO_ERR) {
        return res;
    }

    system_obj =
        ncx_find_object(example_mod,
                        y_example_N_system);
    if (system_obj == NULL) {
        return ERR_NCX_DEF_NOT_FOUND;
    }

    res =
        agt_cb_register_callback(y_example_M_example,
                                 (const xmlChar *)"/ex:system",
                                 y_example_R_example,
                                 example_system_edit);
    if (res != NO_ERR) {
        return res;
    }

    res =
        agt_cb_register_callback(y_example_M_example,
                                 (const xmlChar *)"/ex:system/ex:host-name",
                                 y_example_R_example,
                                 example_system_host_name_edit);
    if (res != NO_ERR) {
        return res;
    }

    res =
        agt_cb_register_callback(y_example_M_example,
                                 (const xmlChar *)"/ex:system/ex:domain-search",
                                 y_example_R_example,
                                 example_system_domain_search_edit);
    if (res != NO_ERR) {
        return res;
    }

    res = u_example_init(modname, revision);
    return res;

} /* y_example_init */


/********************************************************************
* FUNCTION y_example_init2
*
* SIL init phase 2: non-config data structures
* Called after running config is loaded
*
* RETURNS:
*     error status
********************************************************************/
status_t y_example_init2 (void)
{
    status_t res = NO_ERR;

    system_val = agt_init_cache(y_example_M_example,
                                y_example_N_system,
                                &res);
    if (res != NO_ERR) {
        return res;
    }

    res = u_example_init2();

    return res;

} /* y_example_init2 */


/********************************************************************
* FUNCTION y_example_cleanup
*    cleanup the server instrumentation library
*
********************************************************************/
void y_example_cleanup (void)
{

    agt_cb_unregister_callbacks(y_example_M_example,
                                (const xmlChar *)"/ex:system");

    agt_cb_unregister_callbacks(y_example_M_example,
                                (const xmlChar *)"/ex:system/ex:host-name");

    agt_cb_unregister_callbacks(y_example_M_example,
                                (const xmlChar *)"/ex:system/ex:domain-search");

    u_example_cleanup();

} /* y_example_cleanup */

/* END SIL y_example.c */
