#ifndef _H_y_example
#define _H_y_example
/*
 * Copyright (c) 2008 - 2012, Andy Bierman, All Rights Reserved.
 * Copyright (c) 2012 - 2020, YumaWorks, Inc., All Rights Reserved.
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 *

*** Generated by yangdump-sdk

    YumaPro SIL header
    module example
    revision 2020-03-03
    namespace http://netconfcentral.org/ns/example
    Created: 2020-03-05T23:22:42Z
    CLI parameters:
        format yh
        indent 4
        log-level debug3
        module example
        output y_example.h
        unified true

 */

#include <xmlstring.h>

#include "dlq.h"
#include "ncxtypes.h"
#include "op.h"
#include "status.h"
#include "val.h"

#ifdef __cplusplus
extern "C" {
#endif

#define y_example_M_example (const xmlChar *)"example"
#define y_example_R_example (const xmlChar *)"2020-03-03"

#define y_example_N_domain_search (const xmlChar *)"domain-search"
#define y_example_N_host_name (const xmlChar *)"host-name"
#define y_example_N_system (const xmlChar *)"system"


/********************************************************************
* FUNCTION y_example_init
*
* initialize the example server instrumentation library
*
* INPUTS:
*    modname == requested module name
*    revision == requested version (NULL for any)
*
* RETURNS:
*     error status
********************************************************************/
extern status_t
    y_example_init (const xmlChar *modname,
                    const xmlChar *revision);


/********************************************************************
* FUNCTION y_example_init2
*
* SIL init phase 2: non-config data structures
* Called after running config is loaded
*
* RETURNS:
*     error status
********************************************************************/
extern status_t y_example_init2 (void);


/********************************************************************
* FUNCTION y_example_cleanup
*    cleanup the server instrumentation library
*
********************************************************************/
extern void y_example_cleanup (void);


#ifdef __cplusplus
} /* end extern 'C' */
#endif

#endif
